
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ExportsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exports = await db.exports.create(
            {
                id: data.id || undefined,
        
        format: data.format
        ||
        null
            ,
            
        quality: data.quality
        ||
        null
            ,
            
        include_stems: data.include_stems
        ||
        false
        
            ,
            
        status: data.status
        ||
        null
            ,
            
        requested_at: data.requested_at
        ||
        null
            ,
            
        completed_at: data.completed_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await exports.setSong( data.song || null, {
            transaction,
        });
        
        await exports.setRequested_user( data.requested_user || null, {
            transaction,
        });
        
        await exports.setExport_asset( data.export_asset || null, {
            transaction,
        });
        
        await exports.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return exports;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const exportsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                format: item.format
            ||
            null
            ,
            
                quality: item.quality
            ||
            null
            ,
            
                include_stems: item.include_stems
            ||
            false
        
            ,
            
                status: item.status
            ||
            null
            ,
            
                requested_at: item.requested_at
            ||
            null
            ,
            
                completed_at: item.completed_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const exports = await db.exports.bulkCreate(exportsData, { transaction });

        // For each item created, replace relation files
        

        return exports;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const exports = await db.exports.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.format !== undefined) updatePayload.format = data.format;
        
        
        if (data.quality !== undefined) updatePayload.quality = data.quality;
        
        
        if (data.include_stems !== undefined) updatePayload.include_stems = data.include_stems;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.requested_at !== undefined) updatePayload.requested_at = data.requested_at;
        
        
        if (data.completed_at !== undefined) updatePayload.completed_at = data.completed_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await exports.update(updatePayload, {transaction});

        
        
        if (data.song !== undefined) {
            await exports.setSong(
              
              data.song,
              
              { transaction }
            );
        }
        
        if (data.requested_user !== undefined) {
            await exports.setRequested_user(
              
              data.requested_user,
              
              { transaction }
            );
        }
        
        if (data.export_asset !== undefined) {
            await exports.setExport_asset(
              
              data.export_asset,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await exports.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return exports;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const exports = await db.exports.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of exports) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of exports) {
                await record.destroy({transaction});
            }
        });


        return exports;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const exports = await db.exports.findByPk(id, options);

        await exports.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await exports.destroy({
            transaction
        });

        return exports;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const exports = await db.exports.findOne(
            { where },
            { transaction },
        );

        if (!exports) {
            return exports;
        }

        const output = exports.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.song = await exports.getSong({
            transaction
        });
        
        
        output.requested_user = await exports.getRequested_user({
            transaction
        });
        
        
        output.export_asset = await exports.getExport_asset({
            transaction
        });
        
        
        output.organizations = await exports.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.songs,
        as: 'song',
        
        where: filter.song ? {
          [Op.or]: [
            { id: { [Op.in]: filter.song.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.song.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'requested_user',
        
        where: filter.requested_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requested_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.requested_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.assets,
        as: 'export_asset',
        
        where: filter.export_asset ? {
          [Op.or]: [
            { id: { [Op.in]: filter.export_asset.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.export_asset.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.requested_atRange) {
                const [start, end] = filter.requested_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.completed_atRange) {
                const [start, end] = filter.completed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    completed_at: {
                    ...where.completed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.format) {
                where = {
                    ...where,
                format: filter.format,
            };
            }
            
            if (filter.quality) {
                where = {
                    ...where,
                quality: filter.quality,
            };
            }
            
            if (filter.include_stems) {
                where = {
                    ...where,
                include_stems: filter.include_stems,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.exports.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'exports',
                        'format',
                        query,
                    ),
                ],
            };
        }

        const records = await db.exports.findAll({
            attributes: [ 'id', 'format' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['format', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.format,
        }));
    }

    
};

